' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Code geprüft jedoch ohne jegliche Gewährleistung
' Nutzung auf eigenes Risiko
' Copyright (c) 2014 by GMG-CC.de
' G.Mumme@GMG-CC.de
' Erstellt durch Günther Mumme
' Der Code darf den lokalen Bedürfnissen angepasst werden
' Zum Zeitpunkt des Uploads können wir Viren-Freiheit garantieren
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
' Weitergabe und Vervielfältigung des Code ist nur mit diesem
' kompletten Hinweis erwünscht und erlaubt.
' Der Zweck ergibt sich aus dem Code an sich oder ist in dem
' Link, der zu diesem Download führte, beschrieben.
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Option Explicit

Sub ZeilenEinfuegenBereich()
   ' Hinweis: Die 1. Zeile werde stets OBERHALB der Markierung eingefügt
   Dim lngAnzRows As Long, lngMaxRow As Long
   Dim lngAnzRowsSel As Long, lngAnzRowsWks As Long
   Dim lngLastDataRow As Long, lngFirstDataRow As Long, lngFreeRows As Long
   Dim i As Long
   Dim bolPartOnly As Boolean
   
   lngAnzRowsWks = Rows.Count     'Maximale/alle Zeilen des WorkSheets
   lngLastDataRow = ActiveSheet.Cells(lngAnzRowsWks, 1).End(xlUp).Row  'Letzte Datenzeile
   'Hier wird die erste Leerzeile eingefügt, falls nicht mehrere Zeilen markiert sind. bei Bedarf ändern
   lngFirstDataRow = 2
   lngFreeRows = lngAnzRowsWks - lngLastDataRow   'Noch freie Zeilen
   lngMaxRow = lngFreeRows / 2   'Die Hälfte davon
   lngAnzRowsSel = lngLastDataRow
   
   ' Prüfen, ob mehrere Zeilen zusammenhängend markiert sind
   If Selection.Rows.Count > 1 Then
      If MsgBox(lngAnzRowsSel & " Zeilen sind zusammenhängend markiert," & vbCrLf _
         & "sollen nur in diesem Bereich Leerzeilen eingefügt werden?", _
         vbYesNo, "Bereich festlegen") = vbYes Then
         '
         bolPartOnly = True
         lngAnzRowsSel = Selection.Rows.Count
         lngFirstDataRow = Selection.Row
         lngAnzRows = Selection.Rows.Count
         lngLastDataRow = lngFirstDataRow + lngAnzRows - 1
      End If
   End If
   
   On Error GoTo Fehler
   Application.ScreenUpdating = False 'Wegen Schnelligkeit und Flimmern
   
   If lngMaxRow >= lngAnzRowsSel Then
      For i = lngLastDataRow To lngFirstDataRow Step -1
         Rows(i).EntireRow.Insert
      Next i
      ' Falls nach der letzten markierten Zeile KEINE Leerzeile eingefügt werden soll,
      ' die folgende Zeile auskommentieren oder löschen
      If bolPartOnly Then Rows(lngLastDataRow + lngAnzRowsSel + 1).EntireRow.Insert
   Else  'Es wären zu viele Zeilen
      MsgBox "Zu viele Datenzeilen," & vbCrLf _
      & "ein Einfügen von Leerzeilen ist nicht möglich.", _
      vbCritical + vbOKOnly, "Fehler!"
   End If
   
Fehler:
   Application.ScreenUpdating = True
End Sub